require_dependency "grpc_auth/application_controller"

module GrpcAuth
  class AuthController < ApplicationController
    def login
    end

    def logout
      flash[:notice]="你已经登出"
      reset_session
      redirect_to  main_app.root_path
    end

    def auth
      unless verify_rucaptcha?
        flash[:alert] = "验证码出错"
        redirect_to main_app.root_path and return
      end

      login = params[:login]
      psd = params[:password]
      hsh = gauth(login,psd)
      if hsh == false
        redirect_to login_path , alert: "用户信息有误" and return
      else
        name = hsh.RealName
        groups = hsh.Tags
        session[:login] = login
        session[:realname] = name
        session[:groups] = groups
        redirect_to main_app.root_path and return
      end
    end

    private

    def gauth(login,passwd)
      request = Grpcd::AuthRequest.new(Login: login,Password: passwd)
      begin
        reply = stub.auth(request)
      rescue
        return false
      else
        return reply
      end
    end
  end
end
